<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Controller\Adminhtml\Schedule;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\ScheduleInterface;

class Save extends Adminhtml\Operation
{
    public function execute()
    {
        $data = $this->getRequest()->getParams();
        $id = $data[ScheduleInterface::SCHEDULE_ID];

        try {
            if ($id) {
                /** @var $model \Magento\Cron\Model\Schedule */
                $model = $this->_objectManager->create('Magento\Cron\Model\Schedule');
                $model->load($id);
                if ($model->getId()) {
                    $model->setData($data)->save();
                    $name = $model->getJobCode();
                    $time = $model->getScheduledAt();
                    $this->messageManager->addSuccess(
                        __('Schedule %1 at %2 saved', $name, $time)
                    );
                }
            } else {
                $this->messageManager->addError(__('Data ID missing - error'));
            }
        } catch (\Exception $e) {
            $this->logger->critical($e->getMessage());
            $this->messageManager->addError(__('Operation error'));
            $this->_session->setFormData($data);
            return $this->_redirect(
                '*/schedule/edit',
                ['id' => $id, 'back' => null, '_current' => true]
            );
        }

        return $this->getRequest()->getParam('back') ?
            $this->_redirect('*/schedule/edit', ['schedule_id' => $id, 'back' => null, '_current' => true]) :
            $this->_redirect(static::REDIRECT_URL);
    }
}
