<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Model;

use Magento\Cron\Model\Config\Data;
use Neklo\Scheduler\Api\Data\JobInterface;

/**
 * Class Config
 * @package Neklo\Scheduler\Model
 */
class Config extends \Magento\Cron\Model\Config
{
    /**
     * @var JobFactory
     */
    private $jobFactory;

    /**
     * Config constructor.
     * @param Data $configData
     * @param JobFactory $jobFactory
     */
    public function __construct(
        Data $configData,
        JobFactory $jobFactory
    )
    {
        parent::__construct($configData);
        $this->jobFactory = $jobFactory;
    }

    /**
     * @return array
     */
    public function getJobs()
    {
        $jobs = parent::getJobs();

        $coll = $this->jobFactory->create()->getCollection();
        $coll->addFieldToFilter('enabled', true);

        foreach ($coll->getItems() as $item) {
            $jobs[$item->getGroup()][$item->getName()] = $item->getData();
        }

        return $jobs;
    }
}
