<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/

namespace Neklo\Scheduler\Model\Schedule;

class Filters
{
    const FILTER_CLEAR = 'timeline_clear';
    const FILTER = 'timeline_filters';

    private $data = [];

    public function __construct(
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->request = $request;
        $req = $this->request->getParams();
        if (isset($req[self::FILTER])) {
            $this->data = $req[self::FILTER];
            foreach ($this->data as $name => $filters) {
                if (is_array($filters)) {
                    foreach ($filters as $key => $value) {
                        $this->data[$name][$key] = $value;
                    }
                }
            }
        } else {
            $this->data['scheduled'] = [
                'date_from' => null,
                'date_to'   => null,
            ];
        }
    }

    public function getData()
    {
        return $this->data;
    }

    public function getFormData()
    {
        $out = [];
        foreach ($this->data as $name => $value) {
            foreach ($value as $name2 => $value2) {
                $out[self::FILTER . "[$name][$name]"] = $value;
            }
        }
    }
}
